 use "PCStocks.dta", clear
 *desc, fullnames
 format date %d
 
 format distcd %4.0f
 count if missing(prc)
 drop if missing(prc)
 *tab comnam
 *tab comnam permno
 gen name = comnam
 replace name = "Commodore" if regexm(lower(name),"commodore")
 replace name = "Dell" if regexm(lower(name),"dell")
 replace name = "Gateway" if regexm(lower(name),"gateway")
 replace name = "Apple" if regexm(lower(name),"apple")

 ***PC ONLY (Apple, Atari, Commodor, Compaq, Dell)
keep if permno == 14593 /*APPLE*/ | permno == 70375 /*Atari*/ /*
*/ | permno == 57795 /*Commodore*/ | permno == 68347 /*Compaq*/ |permno == 11081 /*DELL*/


sort permno date
by permno: gen firstprc = prc[1]
by permno: gen firstdate = _n==1
by permno: gen secondate = _n==2
***If not firstdate...
egen groupno = group(date)
gen mrkcap = abs(prc)*shrout
by permno: g mrkcapfirst = mrkcap[1]

gsort date -firstdate
by date: gen first = _n==1
sort date firstdate
by date: egen everfd = total(firstdate)
by date: egen totmktcap = total(mrkcap) if ~firstdate
by date: replace totmktcap = totmktcap[_n-1] if firstdate & date==date[_n-1]
by date: egen totmktcapfull = total(mrkcap) 
gsort date -firstdate -first
capture drop lagtotcap
g lagtotcap = totmktcap[_n-1] if first
by date: replace lagtotcap = lagtotcap[1]
capture drop lagtotcapfull
gen lagtotcapfull = totmktcapfull[_n-1] if first
by date: replace lagtotcapfull = lagtotcapfull[1]


gen totprcwght = mrkcap/totmktcap

replace totprcwght = mrkcap/lagtotcap if everfd~=0 & groupno>1
***Still need to adjust prices for splits and the like. The factor code 1 indicates a 1:1
g mrkcapindx = mrkcap/mrkcapfirst
g valwght = (mrkcapindx*totprcwght)*(firstdate==0)      
by date: egen indxprc = total(valwght)
sort date
replace sprtrn = 10 if _n==1
gsort -first date
g spindx = 10
replace spindx = spindx[_n-1]*(1+sprtrn) if first & groupno>1

gen basevalue = 1
gsort date -secondate
g indxfctor = 10
replace indxprc = 1 if _n==1
replace indxfctor =  indxprc[_n-1] if secondate
sort permno date
by permno: replace indxfctor = indxfctor[_n-1] if ~secondate & groupno>2
replace valwght = (indxfctor*mrkcapindx*totprcwght)*(firstdate==0)   
bys date: egen indxprcfct = total(valwght)
g year = year(date)
format date %dccYY
label var indxprcfct "PC Index"
label var spindx "S&P 500"
line indxprcfct date if first & year(date)<2010 & year(date) > 1976
line indxprcfct date if first & year(date)<2015 & year(date) > 1976 || line spindx date if first & year(date)<2015& year(date) > 1976, yaxis(2)
browse date name mrkcap basevalue indxprc prc firstdate secondate first totmkt* lag* if first

keep if first
rename indxprcfct pc_index
keep pc_index date 

save "pc_index", replace
