****Bubbles and Crashes, Chapter 5 code
**Data for the table in Appendix for Wharton30
**Also calculates all correlations in Chapter 5
**Published factor levels are incorrect in book 
**Novicebin was miscoded (scaled between 1-3 as opposed to 0-2).
**Thus, published factor levels are all incremented by 1
**This does not effect correlations reported in book.
**For variable keys, see labels in Stata.
 ***Data uses stata15
capture log close
use tech ctrlun Wow_factor Public_Interest Paradigm_Shift Knowit DifVersions Obsolete /*
*/ disrupt Analogies b2bb2c ClearBiz collective_experience /*
*/ ControlManu13 ControlMktS ControlIP /*
 */ techbizValChainun  components  system   narrative /*
 */  novicebin BubOpS BubOpE timingcomment  CtrlUnc techbizunc narrativebin atrisk/*
 */ i_frothiness_choice i_pctfall_choice i_relbub_choice date_bub nobub /*
 */ using "Wharton30_data_labeled", clear
export excel using "Wharton30_data_labeled", first(var) replace
label var novicebin "2 if bubble opportunity includes 1998-2015, 1 otherwise"


g factors = CtrlUnc + techbizunc + narrativebin + novicebin
***Check and see correlation with old coding

g factors2 = factors


replace factors2 = 7 if regexm(tech,"(media|open)") /*Recoded, per discussion in book, viewed as part of the internet bubble*/
 ***take out fiber - make the bubble opportunity end earlier, and hence no index?

label var factors "Factor total if media file compression and open source are viewed as independend tech"
label var factors2 "Factor total if media file compression and open source are viewed as internet tech"
 
 ***To see what happens with fiber included, don't run these next 5 lines
 ***If fiber is included, then this assumes corning is a pureplay for fiber.
 replace atrisk = 0 if regexm(tech,"(fiber)")
 replace i_frothiness_choice = . if atrisk ==0
 replace i_pctfall_choice = . if atrisk ==0
 replace i_relbub_choice = . if atrisk ==0
 replace date_bub = . if atrisk==0
 replace nobub=. if atrisk ==0
 
 
sort atrisk factors tech
 capture drop froth_art
 by atrisk factors: gen froth_art =  (-_N/2+_n)*.5  

 g froth_art2 = froth_art/15
  replace froth_art2 = froth_art2 -0.09

  

 ***Arrange everything so that labels are readable 
  g pos = 6
  replace pos = 0 if tech=="microprocessor"
 replace pos = 12 if regexm(tech,"(open source)")
 replace pos = 1 if regexm(tech, "(pcs|media file compression)")
 replace pos = 6 if regexm(tech,"(office software|genetically|media)")
 replace tech = "media file comp." if tech == "media file compression"
 
 ***Minor deviations for graph readability
 replace factors2 = 1.15 if regexm(tech, "(bar|stents|turbines|retrovirals)")
 replace factors2 = 6.85 if regexm(tech, "(open|media|line|internet)")
  
  set scheme s2mono
twoway scatter i_pctfall_choice factors2 if atrisk==1, msize(tiny) mlab(tech) mlabsize(tiny) mlabp(3) /*
 */mcolor(blue) msymbol(i) mlabvpos(pos) ylabel(0(.1)1) ytitle("Percentage Fall Peak to Trough") xtitle("factors") legend(off)|| /*
 */scatter froth_art2 factors2 /*
 */ if atrisk==0, msize(vtiny) mlab(tech) mlabsize(tiny) mlabp(3)  /*
 */ mcolor(red) mlabang(0) msymbol(i) mlabpos(0)  ylabel(0(.1)1) yline(0, lp(dash)) legend(off) xtitle("factors")
 
 graph save "Fig5_1_corrected", replace
 graph export "Fig5_1_corrected.png", width(800) height(600) replace
gsort -atrisk factors 

***Export data for Appendix table
format %tm date_bub
label values  CtrlUnc techbizunc narrativebin novicebin lmh 
label values atrisk nobub yn
format %tm date_bub
 export excel  using "Wharton30_processed", first(var) replace

 *stats reported in book, note, factors= factors-1 vis a vis what is reported in the book because of novicebin coding error
 pwcorr  factors factors2 atrisk i_*choice 
 tabstat factors factors2, by(atrisk) st(mean)
log using Ch5_Codebook, replace text
codebook
log close 


